



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python顺序集合之 tuple</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python顺序集合之 tuple</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 08:11:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>慕课网《Python 入门》学习笔记</p>
<p>1、tuple特性</p>
<p>tuple是另一种有序的列表，中文翻译为&ldquo;&nbsp;元组&nbsp;&rdquo;。tuple 和 list 非常类似，但是，tuple一旦创建完毕，就不能修改了。</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; t = ('Adam', 'Lisa', 'Bart') </pre>
<p>创建tuple和创建list唯一不同之处是用<code>( )</code>替代了<code>[ ]</code>。</p>
<p>现在，这个<code>&nbsp;t&nbsp;</code>就不能改变了，tuple没有 append()方法，也没有insert()和pop()方法。所以，新元素没法直接往 tuple 中添加，在 tuple删除元素 也不行。</p>
<p>获取 tuple 元素的方式和 list 是一模一样的，可以正常使用 t[0]，t[-1]等索引方式访问元素，但是不能赋值成别的元素。</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; t[0] = 'Paul'</pre>
<pre class="prettyprint linenums"> Traceback (most recent call last):</pre>
<pre class="prettyprint linenums"> File "", line 1, in</pre>
<pre class="prettyprint linenums"> TypeError: 'tuple' object does not support item assignment</pre>
<p>2、创建单元素tuple</p>
<p>包含 0 个元素的 tuple，也就是空tuple，直接用 ()表示：</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; t = ()</pre>
<pre class="prettyprint linenums"> &gt;&gt;&gt; print t</pre>
<pre class="prettyprint linenums"> ()</pre>
<p>创建包含1个元素的 tuple 呢？来试试：</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; t = (1)</pre>
<pre class="prettyprint linenums"> &gt;&gt;&gt; print t</pre>
<pre class="prettyprint linenums"> 1</pre>
<p>因为<code>()</code>既可以表示tuple，又可以作为括号表示运算时的优先级，结果 (1) 被Python解释器计算出结果 1，导致我们得到的不是tuple，而是整数 1。</p>
<p>正是因为用()定义单元素的tuple有歧义，所以 Python 规定，单元素 tuple 要多加一个逗号&ldquo;,&rdquo;，这样就避免了歧义：</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; t = (1,)</pre>
<pre class="prettyprint linenums"> &gt;&gt;&gt; print t</pre>
<pre class="prettyprint linenums"> (1,)</pre>
<p>Python在打印单元素tuple时，也自动添加了一个&ldquo;,&rdquo;，为了更明确地告诉你这是一个tuple。</p>
<p>3、"可变&rdquo;的tuple</p>
<p>tuple也是&ldquo;可变&rdquo;的，如：</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; t = ('a', 'b', ['A', 'B'])</pre>
<p><strong>注意</strong>到 t 有 3 个元素：<strong>'a'，'b'</strong>和一个list：<strong>['A', 'B']</strong>。list作为一个整体是tuple的第3个元素。list对象可以通过 t[2] 拿到：</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; L = t[2]</pre>
<p>然后，我们把list的两个元素改一改：</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; L[0] = 'X'</pre>
<pre class="prettyprint linenums"> &gt;&gt;&gt; L[1] = 'Y'</pre>
<p>再看看tuple的内容：</p>
<pre class="prettyprint linenums"> &gt;&gt;&gt; print t</pre>
<pre class="prettyprint linenums"> ('a', 'b', ['X', 'Y'])</pre>
<pre class="prettyprint linenums">表面上看，tuple的元素确实变了，但其实变的不是 tuple 的元素，而是list的元素。<br />tuple一开始指向的list并没有改成别的list，所以，tuple所谓的<strong>&ldquo;不变&rdquo;</strong>是说，tuple的每个元素，指向永远不变。即<strong>指向'a'，就不能改成指向'b'</strong>，指向一个list，就不能改成指向其他对象，但指向的这个list本身是可变的！<br />理解了<strong>&ldquo;指向不变&rdquo;</strong>后，要创建一个内容也不变的tuple怎么做？那就必须保证tuple的每一个元素本身也不能变。</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2jr1o8.html">理解PagerAdapter的instantiateItem&lpar;&rpar;方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/390jwx48.html">一文说尽C&plus;&plus;赋值运算符重载函数&lpar;operator&equals;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p3zndq.html">使用composer管理php项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zxjvnq.html">内存溢出OOM与内存泄漏ML</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96elvvq.html">多线程socket编程示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql6ge6q.html">Linux Purify命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jym149.html">MAC环境下 nodejs 4&period;5&period;0 卸载</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xdvze8.html">&lbrack;转&rsqb;eclipse中使用maven插件的时候，运行run as maven build的时候报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd6omm8.html">shell复习笔记----命令与参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn47jv8.html">创建一个&period;bat文件，用于打开某个路径下的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wo4mxq.html">Android 6&period;0权限问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgjeyq.html">C&plus;&plus;の友元の例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde64zz9.html">activity的横屏和竖屏设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8menzepq.html">CentOS 6&period;4下编译安装MySQL 5&period;6&period;16</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgg73r8.html">读书时间《JavaScript高级程序设计》七：表单</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p2dky8.html">利用Python爬取新浪微博营销案例库并下载到本地</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geylz48.html">【翻译】使用Sencha Ext JS创建美丽的图画（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyk3y19.html">js强制不使用&OpenCurlyDoubleQuote;兼容性视图&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jpv75q.html">node访问oracledb的环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjpn509.html">教你使用HTML5原生对话框元素，轻松创建模态框组件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e1epex9.html">CodeForces 12C Fruits</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xo0109.html">Mysql ERROR 1064 （42000）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yygw3q.html">&lbrack;POJ3667&rsqb;Hotel（线段树，区间合并）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn11mkg8.html">【原创】OPA857 TEST模式使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwddkpy8.html">安装 SQLManagementStudio&lowbar;x86&lowbar;CHS&lpar;SQL Server Management Studio&rpar; 老提示重启的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvv5lyq.html">pupper基线加固</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wwwxwq.html">PE结构笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmmjoe9.html">Java&mdash;&mdash;FIle：</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j001ygq.html">&lbrack;poj2286&rsqb;The Rotation Game &lpar;IDA&ast;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnnl26q.html">mysql 中文字段排序&lpar; 按拼音首字母排序&rpar; 的查询语句</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
